#include "Triangle.h"

Triangle::Triangle(const Vector3& p0, const Vector3& p1, const Vector3& p2,
                   int object_id, int shader_id) :
  p0(p0), p1(p1), p2(p2), object_id(object_id), shader_id(shader_id)
{
	// do we compute 2 edges to store instead of points?
	// p0 (edge between p1 and p0), p1 (central point), p2 (edge between p2 and p1)
#ifdef TRIANGLES_STORE_EDGES
	this->p0 -= p1;
	this->p2 -= p1;
#endif
}

Triangle::Triangle(const Triangle& t) :
p0(t.p0), p1(t.p1), p2(t.p2), object_id(t.object_id), shader_id(t.shader_id)
{
	// do we compute 2 edges to store instead of points?
	// p0 (edge between p1 and p0), p1 (central point), p2 (edge between p2 and p1)
#ifdef TRIANGLES_STORE_EDGES
	this->p0 -= p1;
	this->p2 -= p1;
#endif

}

Triangle::Triangle()
{}

void Triangle::LoadIntoMemory(int& memory_position, int max_memory,
                              FourByte* memory) {
  // write type into this location
  //memory[memory_position].ivalue = Primitive::TRIANGLE_TYPE;
  //memory_position++;
  for (int i = 0; i < 3; i++) {
    memory[memory_position].fvalue = p0[i];
    memory_position++;
  }
  for (int i = 0; i < 3; i++) {
    memory[memory_position].fvalue = p1[i];
    memory_position++;
  }
  for (int i = 0; i < 3; i++) {
    memory[memory_position].fvalue = p2[i];
    memory_position++;
  }
  memory[memory_position].ivalue = object_id;
  memory_position++;
  memory[memory_position].ivalue = shader_id;
  memory_position++;
}
